*!
*!       Function: SAYLINE()
*!
*!       3/31/92 EasySystem, Inc.
*!       Richmond, VA
*!*********************************************************************

**  this is a cute deal for formatting the line output for
**  up to a five column spreadsheet type columnar reports
m*  If you pass 0 as the parameter for c3,c4,c5, or c6, the third,
**  fourth, fifth, and sixth colums will not be printed
**  Pass z as a null char param for any of the pic_ or c_ vars
*
** Particularly useful for do while... loops and totals, as in following
** long code example:
*     open "insco.dbf" alias insco index inscodex
*     open "keypol.dbf" alias keypol index codate, bookdate
*
*     !insco goto top
*     do while .not. a_eof(insco)
*          !keypol set index to codate
*          !insco store insco->inscompany to minscompany
*          !insco store capfirst(insco->name) to mname
*          seek1 = minscompany+i_str(year(today()))
*          seek2 = minscompany+i_str((year(today())-1))
*          seek3 = minscompany+i_str((year(today())-2))
*          seek4 = minscompany+i_str((year(today())-3))
*
*
*
*          !keypol goto top
*          !keypol seek seek1
*          if       found()
*               !keypol sum rest keypol->premium  while (keypol->inscompany = minscompany  .and. year(keypol->bookdate) = year(today())) to prem1
*          else
*          prem1 = 0
*          endif
*          !keypol goto top
*          !keypol seek seek2
*            if       found()
*               !keypol sum rest keypol->premium  while (keypol->inscompany = minscompany  .and.   year(keypol->bookdate) = (year(today())-1)) to prem2
*          else
*          prem2 = 0
*          endif
*          !keypol goto top
*          !keypol seek seek3
*          if       found()
*               !keypol sum rest keypol->premium  while (keypol->inscompany = minscompany  .and.   year(keypol->bookdate) = (year(today())-2)) to prem3
*          else
*          prem3 = 0
*          endif
*          !keypol goto top
*          !keypol seek seek4
*          if       found()
*               !keypol sum rest keypol->premium  while (keypol->inscompany = minscompany .and.   year(keypol->bookdate) = (year(today())-3)) to prem4
*          else
*          prem4 = 0
*          endif
*          set device to print
*          sayline(lineno,"AAAAAAAAAAAAAAAAAAAA","@Z",z,2,mname,25,str(prem1,10,2),38,str(prem2,10,2),51,str(prem3,10,2),65,str(prem4,10,2),0,z)
*          set device to screen
*
*             lineno = lineno+2
*         !insco skip
*         loop
*    enddo
*
*******************************************************************************
*  or use it to create page or column titles and headers, as in:
*
*       sayline(8,"@!","@!",z,2,"Insurer or",27,"Premium",40,"Premium",53,"Premium",67,"Premium",0,z)
*       sayline(9,"@!","@!",z,2,"Insurer Group",27,"This Year",40,"Last Year",53,"Next Prior",67,"Third Prior",0,z)
*       sayline(10,"@!","@!",z,27,"Yeartodate",40,"Total",53,"Year total",67,"Year total",0,z,0,z)
************************************************************************************************************

***  OK, here's the barking dog itself:


 function logical sayline
 parameters  value int lineno, ;
           value    char pic1,;
           value    char pic2,;
           value    char pic3,;
           value    int  c1,;
           value    char v1,;
           value    int  c2,;
           value    char v2,;
           value    int  c3,;
           value    char v3,;
           value    int  c4,;
           value    char v4,;
           value    int  c5,;
           value    char v5,;
           value    int  c6,;
           value    char v6

     @ lineno,c1 say v1 picture  pic1
     @ lineno,c2 say v2 picture  pic2
     if c3<>0
          @lineno,c3 say v3 picture  pic2
     endif
     if c4<>0
          @lineno,c4 say v4 picture  pic2
     endif
     if c5<>0
          @lineno,c5 say v5 picture  pic2
     endif
     if c6<>0
          @lineno,c6 say v6 picture  pic2
     endif
endpro
*: EOF: ESAYLINE.PRG
